//
//  ViewController.m
//  testt
//
//  Created by  on 12-1-17.
//  Copyright (c) 2012年 DremTop. All rights reserved.
//

#import "ViewController.h"

#import "PYMethod.h"
#import "pinyin.h"
#import "POAPinyin.h"

@implementation ViewController

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
//    NSString *hanyu = nil;
    /*
     荷塘的四面，远远近近，高高低低都是树，而杨柳最多。这些树将一片荷塘重重围住；只在小路一旁，漏着几段空隙，像是特为月光留下的。树色一例（12）是阴阴的，乍看像一团烟雾；但杨柳的丰姿（13），便在烟雾里也辨得出。树梢上隐隐约约的是一带远山，只有些大意罢了。树缝里也漏着一两点路灯光，没精打采的，是渴睡人的眼。这时候最热闹的，要数树上的蝉声与水里的蛙声；但热闹是它们的，我什么也没有。
     */
    
    
    NSArray* array =[NSArray arrayWithObjects:@",荷塘的四面",@"这些树将一片荷塘重重围住",@"只在小路一旁",@"漏着几段空隙",@"像是特为月光留下的",@"乍看像一团烟雾",@"便在烟雾里也辨得出",@"树梢上隐隐约约的是一带远山",@"只有些大意罢了",@"树缝里也漏着一两点路灯光",@"没精打采的",@"没精打采的",@"没精打采的",@"便在烟雾里也辨得出。树梢上隐隐约约的是一带远山，只有些大意罢了。树缝里也漏着一两点路灯光，没精打采的，是渴睡人的眼。这时候最热闹的，要数树上的蝉声与水里的蛙声",@"但热闹是它们的，我什么也没有", nil];
    
    
    for (NSString *hanyu in array) {
        // pinyin
        clock_t begin = clock();
        NSMutableString* string = [NSMutableString stringWithString:@""];
        for (int i = 0; i < [hanyu length]; i++)
            [string appendFormat:@"%c",pinyinFirstLetter([hanyu characterAtIndex:i])];
        NSLog(@"%@",string);
        clock_t end = clock();
        NSLog(@"pinyin:%f s",(end - begin)/(float)CLOCKS_PER_SEC);
        // symbol
        begin = clock();
        NSLog(@"%@",[PYMethod getPinYin:hanyu]);
        end = clock();
        NSLog(@"smbol:%f s",(end - begin)/(float)CLOCKS_PER_SEC);    
        
        // oapinyin
        begin = clock();
        NSLog(@"%@",[POAPinyin quickConvert:hanyu]);
        end = clock();
        NSLog(@"quick:%f s",(end - begin)/(float)CLOCKS_PER_SEC);
        
        begin = clock();
        NSLog(@"%@",[POAPinyin convert:hanyu]);
        end = clock();
        NSLog(@"origin:%f s",(end - begin)/(float)CLOCKS_PER_SEC);
        
        begin = clock();
        NSLog(@"%@",[POAPinyin stringConvert:hanyu]);
        end = clock();
        NSLog(@"myString:%f s",(end - begin)/(float)CLOCKS_PER_SEC);
        
        NSLog(@"\n\n");
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

-(BOOL)textFieldShouldReturn:(UITextField *)atextField
{
//    label.text = [PYMethod getPinYin:atextField.text];
    label.text = [POAPinyin stringConvert:atextField.text];
    
    return YES;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

@end
